Package: egg
Type: Package
Title: Extensions for 'ggplot2': Custom Geom, Custom Themes, Plot
        Alignment, Labelled Panels, Symmetric Scales, and Fixed Panel
        Size
Version: 0.4.5
Authors@R: c(person("Baptiste", "Auguie",
    email = "baptiste.auguie@gmail.com",
    role = c("aut", "cre")))
License: GPL-3
Description: Miscellaneous functions to help customise 'ggplot2' objects. High-level functions are provided to post-process 'ggplot2' layouts and allow alignment between plot panels, as well as setting panel sizes to fixed values. Other functions include a custom 'geom', and helper functions to enforce symmetric scales or add tags to facetted plots.
VignetteBuilder: knitr
Depends: gridExtra (>= 2.3), ggplot2
Imports: gtable, grid, grDevices, utils
Suggests: knitr, png
RoxygenNote: 6.1.1
NeedsCompilation: no
Packaged: 2019-07-13 05:29:16 UTC; baptiste
Author: Baptiste Auguie [aut, cre]
Maintainer: Baptiste Auguie <baptiste.auguie@gmail.com>
Repository: CRAN
Date/Publication: 2019-07-13 06:00:27 UTC

# <img src="doc/egg.svg" alt="egg logo" height="40" align="left"> egg: egraphs good

[![Crates.io](https://img.shields.io/crates/v/egg.svg)](https://crates.io/crates/egg)
[![Released Docs.rs](https://img.shields.io/crates/v/egg?color=blue&label=docs)](https://docs.rs/egg/)
[![Main branch docs](https://img.shields.io/badge/docs-main-blue)](https://egraphs-good.github.io/egg/egg/)
[![Zulip](https://img.shields.io/badge/zulip-join%20chat-blue)](https://egraphs.zulipchat.com)

egg is a library for e-graphs and equality saturation.
It can be used to build program optimizers, synthesizers, verifiers, and more.
For more information, see these resources:

- [website](https://egraphs-good.github.io/)
- [tutorial](https://docs.rs/egg/latest/egg/tutorials/)
- [API docs](https://docs.rs/egg/)
- [POPL 2021 paper](https://doi.org/10.1145/3434304)

> Also check out the [egglog](https://github.com/egraphs-good/egglog) 
 system that provides an alternative approach to 
 equality saturation based on Datalog.
 It features a language-based design, incremental execution, and composable analyses.
 See also the [paper](//mwillsey.com/papers/egglog) and the [egglog web demo](https://egraphs-good.github.io/egglog).

Are you using egg?
Please cite using the BibTeX below and
 add your project to the 
 ["Awesome E-graphs" page](https://github.com/philzook58/awesome-egraphs)!

<details class="bibtex">
    <summary>BibTeX</summary>
    <code><pre>@article{2021-egg,
  author = {Willsey, Max and Nandi, Chandrakana and Wang, Yisu Remy and Flatt, Oliver and Tatlock, Zachary and Panchekha, Pavel},
  title = {egg: Fast and Extensible Equality Saturation},
  year = {2021},
  issue_date = {January 2021},
  publisher = {Association for Computing Machinery},
  address = {New York, NY, USA},
  volume = {5},
  number = {POPL},
  url = {https://doi.org/10.1145/3434304},
  doi = {10.1145/3434304},
  abstract = {An e-graph efficiently represents a congruence relation over many expressions. Although they were originally developed in the late 1970s for use in automated theorem provers, a more recent technique known as equality saturation repurposes e-graphs to implement state-of-the-art, rewrite-driven compiler optimizations and program synthesizers. However, e-graphs remain unspecialized for this newer use case. Equality saturation workloads exhibit distinct characteristics and often require ad-hoc e-graph extensions to incorporate transformations beyond purely syntactic rewrites.  This work contributes two techniques that make e-graphs fast and extensible, specializing them to equality saturation. A new amortized invariant restoration technique called rebuilding takes advantage of equality saturation's distinct workload, providing asymptotic speedups over current techniques in practice. A general mechanism called e-class analyses integrates domain-specific analyses into the e-graph, reducing the need for ad hoc manipulation.  We implemented these techniques in a new open-source library called egg. Our case studies on three previously published applications of equality saturation highlight how egg's performance and flexibility enable state-of-the-art results across diverse domains.},
  journal = {Proc. ACM Program. Lang.},
  month = jan,
  articleno = {23},
  numpages = {29},
  keywords = {equality saturation, e-graphs}
}
</pre></code>
</details>

<!-- Check out the [egg web demo](https://egraphs-good.github.io/egg-web-demo) for some quick e-graph action! -->

## Using egg

Add `egg` to your `Cargo.toml` like this:
```toml
[dependencies]
egg = "0.11.0"
```

Make sure to compile with `--release` if you are measuring performance!

## Developing

It's written in [Rust](https://www.rust-lang.org/).
Typically, you install Rust using [`rustup`](https://www.rust-lang.org/tools/install).

Run `cargo doc --open` to build and open the documentation in a browser.

Before committing/pushing, make sure to run `make`, 
 which runs all the tests and lints that CI will (including those under feature flags).
This requires the [`cbc`](https://projects.coin-or.org/Cbc) solver
 due to the `lp` feature.

### Tests

Running `cargo test` will run the tests.
Some tests may time out; try `cargo test --release` if that happens.

There are a couple interesting tests in the `tests` directory:

- `prop.rs` implements propositional logic and proves some simple
  theorems.
- `math.rs` implements real arithmetic, with a little bit of symbolic differentiation.
- `lambda.rs` implements a small lambda calculus, using `egg` as a partial evaluator.


### Benchmarking

To get a simple csv of the runtime of each test, you set the environment variable
`EGG_BENCH_CSV` to something to append a row per test to a csv.

Example:
```bash
EGG_BENCH_CSV=math.csv cargo test --test math --release -- --nocapture --test --test-threads=1
```

Egg version 4.2.0

					                NIIBE Yutaka
					                  2015-04-30

This is another Egg V4 release by the original author.  This release
requires newer Anthy (than version 0.3).

The official maintainer at AIST has no interest about maintenance of
this software.  Official Mailing list, homepage, and FTP site are all
gone now.

Until the official maintainer will work again for the real release (as
he once primised to me), for the time being, I keep this package
running on newer Emacs and newer Anthy.

This release only supports Anthy backend and it's Japanese-only.

Old files are moved to the ATTIC directory.  It will be removed in the
next release, perhaps.  In those files, SJ3 support would work, but I
don't have SJ3 at hand, so, it's not guaranteed.

If you need other features than that, please ask the official
maintainer or use old software with old Emacs.
-- 

			   Tamago Version 4

		   NIIBE Yutaka <gniibe@chroot.org>
		   KATAYAMA Yoshio <kate@pfu.co.jp>
		   TOMURA Satoru <tomura@etl.go.jp>


「たまご第4版」(Tamago 4)を公開します。使用許諾条件は GPL です。すべて
のソースが Emacs Lisp で実現されており、GNU Emacs 20.5 以降で多言語入
力環境を提供します。バックエンドサーバとしては、FreeWnn (jserver,
cserver, tserver), Wnn6, SJ3 Ver.2 に対応しています。

FTP site は http://www.m17n.org/pub/tamago です。公式ホームページは
http://www.m17n.org/tamago です。

インストールの方法としては、ファイルを解凍して (1) ./configure, (2)
make, (3) make install を実行してください。

M-x set-language-enviromant などで Language-environment を Japanese に
設定すると default input method が japanese-egg-wnn になっています。

Tamago project に関する議論等は Tamago mailing list で行っています。
Tamago project に参加したい方、Tamago 実装を使ってみたい方、Tamago 実
装についての質問・要望、その他 Tamago に関する議論に参加したい方をお待
ちしています。

Tamago mailing list に参加希望の方は tamago-ctl@m17n.org 宛にメイルの
本文に　

   subscribe あなたの名前 

の一行を書いた mail をお送りください。 その後、確認の mail を届きます
ので、その mail の中にある

   confirm PASSWORD あなたの名前 

の１行を本文にして返事を送ってください。 


参考資料として片山さんが Linux Conference 99 で発表した Egg V4 (Egg
Next Generation) をテキストファイルにしたものを doc/lc99.text の置きま
した。ご覧下さい。


From Tamago 4 管理人

戸村 哲（とむら さとる） 〒305-8568 茨城県つくば市梅園1-1-4 
電子技術総合研究所 情報アーキテクチャ部
E-mail: tomura@etl.go.jp Phone: 0298-54-5887 FAX: 0298-54-5891 

#' geom_custom
#'
#' @description Draw user-defined grobs, typically annotations, at specific locations.
#' @param mapping mapping
#' @param data data
#' @param inherit.aes inherit.aes
#' @param ... arguments passed to the geom's draw_group method
#' @importFrom gtable gtable_matrix gtable_add_grob gtable_add_cols gtable_add_rows
#' @importFrom grid nullGrob unit grobTree editGrob grobName
#' @importFrom ggplot2 ggproto ggproto_parent layer
#' @return layer
#' @export
#' @examples
#' library(grid)
#' d <- data.frame(x=rep(1:3, 4), f=rep(letters[1:4], each=3))
#' gl <- replicate(4, matrix(sample(palette(), 9, TRUE), 3, 3), FALSE)
#' dummy <- data.frame(f=letters[1:4], data = I(gl))
#' ggplot(d, aes(f,x)) +
#'   facet_wrap(~f)+
#'   theme_bw() +
#'   geom_point()+
#'   geom_custom(data = dummy, aes(data = data, y = 2),
#'               grob_fun = function(x) rasterGrob(x, interpolate = FALSE,
#'                                                 width=unit(1,'cm'),
#'                                                 height=unit(1,'cm')))
geom_custom <- function(mapping = NULL, data = NULL, inherit.aes = TRUE, ...) {
    layer(geom = GeomCustom, mapping = mapping, data = data, stat = "identity", position = "identity", 
        show.legend = FALSE, inherit.aes = inherit.aes, params = list(...))
}

GeomCustom <- ggproto("GeomCustom", Geom, handle_na = function(self, data, params) {
    data
}, setup_data = function(self, data, params) {
    data <- ggproto_parent(Geom, self)$setup_data(data, params)
    data
}, draw_group = function(data, panel_scales, coord, grob_fun, fun_params = list()) {
    coords <- coord$transform(data, panel_scales)
    gl <- lapply(seq_along(data$data), function(i) {
        .g <- do.call(grob_fun, c(list(data$data[[i]]), fun_params))
        grid::editGrob(.g, x = unit(coords$x[i], "native"), y = unit(coords$y[i], "native"))
    })
    do.call(grobTree, gl)
    
}, required_aes = c("data", "x", "y"))

#' set_panel_size
#'
#' @description Set the panel width/height of a ggplot to a fixed value.
#' @param p ggplot2
#' @param g gtable
#' @param file optional output filename
#' @param margin grid unit
#' @param width grid unit, requested panel width
#' @param height grid unit, requested panel height
#'
#' @importFrom grid unit convertWidth convertHeight grobWidth grobHeight textGrob gpar
#' @importFrom ggplot2 ggplotGrob ggsave
#' @return gtable with fixed panel sizes
#' @export
#' @examples
#' p1 <- qplot(mpg, wt, data=mtcars, colour=cyl)
#' p2 <- p1 + facet_wrap(~carb, nrow=1)
#' grid.arrange(grobs=lapply(list(p1,p2), set_panel_size))
set_panel_size <- function(p = NULL, g = ggplot2::ggplotGrob(p), file = NULL, margin = unit(1, 
    "mm"), width = unit(4, "cm"), height = unit(4, "cm")) {
    panels <- grep("panel", g$layout$name)
    panel_index_w <- unique(g$layout$l[panels])
    panel_index_h <- unique(g$layout$t[panels])
    nw <- length(panel_index_w)
    nh <- length(panel_index_h)
    
    g$widths[panel_index_w] <- rep(width, nw)
    g$heights[panel_index_h] <- rep(height, nh)
    
    if (!is.null(file)) {
        ggplot2::ggsave(file, g, width = grid::convertWidth(sum(g$widths) + margin, unitTo = "in", 
            valueOnly = TRUE), height = grid::convertHeight(sum(g$heights) + margin, unitTo = "in", 
            valueOnly = TRUE))
    }
    
    g
}

#' gtable_frame
#'
#' @description Reformat the gtable associated with a ggplot object into a 3x3 gtable where the central cell corresponds to the plot panel(s).
#' @param g gtable
#' @param width requested width
#' @param height requested height
#' @param debug logical draw gtable cells
#'
#' @importFrom gtable gtable_matrix gtable_add_grob gtable_add_cols gtable_add_rows
#' @importFrom grid unit unit.c nullGrob rectGrob grid.newpage grid.draw
#' @importFrom gridExtra gtable_rbind gtable_cbind
#' @return 3x3 gtable wrapping the plot
#' @export
#' @examples
#' library(grid)
#' library(gridExtra)
#' p1 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
#'   geom_point()
#'
#' p2 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
#'   geom_point() + facet_wrap( ~ cyl, ncol=2, scales = 'free') +
#'   guides(colour='none') +
#'   theme()
#'
#' p3 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
#'   geom_point() + facet_grid(. ~ cyl, scales = 'free')
#'
#' g1 <- ggplotGrob(p1);
#' g2 <- ggplotGrob(p2);
#' g3 <- ggplotGrob(p3);
#' fg1 <- gtable_frame(g1)
#' fg2 <- gtable_frame(g2)
#' fg12 <- gtable_frame(gtable_rbind(fg1,fg2), width=unit(2,'null'), height=unit(1,'null'))
#' fg3 <- gtable_frame(g3, width=unit(1,'null'), height=unit(1,'null'))
#' grid.newpage()
#' combined <- gtable_cbind(fg12, fg3)
#' grid.draw(combined)
gtable_frame <- function(g, width = unit(1, "null"), height = unit(1, "null"), debug = FALSE) {
    panels <- g[["layout"]][grepl("panel", g[["layout"]][["name"]]), ]
    pargins <- g[["layout"]][grepl("panel", g[["layout"]][["name"]]), ]
    ll <- unique(panels$l)
    margins <- if (length(ll) == 1) 
        unit(0, "pt") else g$widths[ll[-length(ll)] + 2]
    tt <- unique(panels$t)
    fixed_ar <- g$respect
    if (fixed_ar) {
        # there lies madness, we want to align with aspect ratio constraints
        ar <- as.numeric(g$heights[tt[1]])/as.numeric(g$widths[ll[1]])
        # a*(b-c) != ab - ac in grid...
        height <- width * (ar/length(ll))  # - sum(margins)* (ar / length(ll))
        g$respect <- FALSE
    }
    
    core <- g[seq(min(tt), max(tt)), seq(min(ll), max(ll))]
    top <- g[seq(1, min(tt) - 1), seq(min(ll), max(ll))]
    bottom <- g[seq(max(tt) + 1, nrow(g)), seq(min(ll), max(ll))]
    left <- g[seq(min(tt), max(tt)), seq(1, min(ll) - 1)]
    right <- g[seq(min(tt), max(tt)), seq(max(ll) + 1, ncol(g))]
    
    fg <- nullGrob()
    
    if (length(left)) {
        # add a dummy grob to make sure things stick to the panel
        lg <- gtable::gtable_add_cols(left, unit(1, "null"), 0)
        lg <- gtable::gtable_add_grob(lg, fg, 1, l = 1)
    } else {
        lg <- fg
    }
    
    if (length(right)) {
        # add a dummy grob to make sure things stick to the panel
        rg <- gtable::gtable_add_cols(right, unit(1, "null"))
        rg <- gtable::gtable_add_grob(rg, fg, 1, l = ncol(rg))
    } else {
        rg <- fg
    }
    
    if (length(top)) {
        # add a dummy grob to make sure things stick to the panel
        tg <- gtable::gtable_add_rows(top, unit(1, "null"), 0)
        tg <- gtable::gtable_add_grob(tg, fg, t = 1, l = 1)
    } else {
        tg <- fg
    }
    
    if (length(bottom)) {
        # add a dummy grob to make sure things stick to the panel
        bg <- gtable::gtable_add_rows(bottom, unit(1, "null"), -1)
        bg <- gtable::gtable_add_grob(bg, fg, t = nrow(bg), l = 1)
    } else {
        bg <- fg
    }
    
    ## 3x3 cells (corners contain nullGrob)
    grobs <- list(fg, tg, fg, lg, core, rg, fg, bg, fg)
    
    widths <- unit.c(sum(left$widths), width, sum(right$widths))
    heights <- unit.c(sum(top$heights), height, sum(bottom$heights))
    all <- gtable::gtable_matrix("all", grobs = matrix(grobs, ncol = 3, nrow = 3, byrow = TRUE), 
        widths = widths, heights = heights)
    
    if (debug) {
        hints <- grid::rectGrob(gp = gpar(fill = NA, lty = 2, lwd = 0.2))
        tl <- expand.grid(t = 1:3, l = 1:3)
        all <- gtable::gtable_add_grob(all, replicate(9, hints, simplify = FALSE), t = tl$t, 
            l = tl$l, z = Inf, name = "debug")
    }
    all[["layout"]][5, "name"] <- "panel"  # make sure knows where the panel is
    if (fixed_ar) 
        all$respect <- TRUE
    all
}

.tmp <- gtable::gtable_matrix("placeholder", matrix(replicate(9, grid::nullGrob(), simplify = FALSE), 
    3, 3), widths = rep(unit(1, "null"), 3), heights = rep(unit(1, "null"), 3))
.tmp$layout$name[5] <- "panel"

#' @export
.dummy_gtable <- .tmp

#' @importFrom ggplot2 ggplot theme_void
#' @export
.dummy_ggplot <- ggplot() + theme_void()


# stolen from grid (because unexported)
as.unit.list <- function(unit) {
    if (inherits(unit, "unit.list")) {
        unit
    } else {
        l <- length(unit)
        result <- vector("list", l)
        for (i in seq_len(l)) result[[i]] <- unit[i]
        class(result) <- c("unit.list", "unit")
        result
    }
}

label_grid <- function(labels, x = 0, hjust = 0, y = 1, vjust = 1, ..., .fun = grid::textGrob) {
    lapply(labels, .fun, x = x, hjust = hjust, y = y, vjust = vjust, ...)
}


#' ggarrange
#'
#' @description Arrange multiple ggplot objects on a page, aligning the plot panels.
#' @param ... ggplot objects
#' @param plots list of ggplots
#' @param nrow number of rows
#' @param ncol number of columns
#' @param heights list of requested heights
#' @param widths list of requested widths
#' @param byrow logical, fill by rows
#' @param top optional string, or grob
#' @param bottom optional string, or grob
#' @param left optional string, or grob
#' @param right optional string, or grob
#' @param padding unit of length one, margin around annotations
#' @param clip argument of gtable
#' @param newpage logical: draw on a new page
#' @param draw logical: draw or return a grob
#' @param debug logical, show layout with thin lines
#' @param labels character labels used for annotation of subfigures
#' @param label.args label list of parameters for the formatting of labels
#' @importFrom grid is.unit is.grob
#' @importFrom grDevices n2mfrow
#' @importFrom gridExtra gtable_cbind gtable_rbind
#' @return gtable of aligned plots
#' @export
#' @examples
#' p1 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
#'   geom_point()
#' p2 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
#'   geom_point() + facet_wrap( ~ cyl, ncol=2, scales = 'free') +
#'   guides(colour='none') +
#'   theme()
#' ggarrange(p1, p2, widths = c(2,1), labels = c('a', 'b'))
ggarrange <- function(..., plots = list(...), nrow = NULL, ncol = NULL, widths = NULL, 
                      heights = NULL, byrow = TRUE, top = NULL, bottom = NULL, left = NULL, right = NULL, 
                      padding = unit(0.5, "line"), clip = "on", draw = TRUE, newpage = TRUE, debug = FALSE, 
                      labels = NULL, label.args = list(gp = grid::gpar(font = 4, cex = 1.2))) {
    n <- length(plots)
    grobs <- lapply(plots, ggplot2::ggplotGrob)
    
    
    ## logic for the layout if nrow/ncol supplied, honour this if not, use length of
    ## widths/heights, if supplied if nothing supplied, work out sensible defaults
    
    ## nothing to be done but check inconsistency
    if (!is.null(ncol) && !is.null(widths)) {
        stopifnot(length(widths) == ncol)
    }
    if (!is.null(nrow) && !is.null(heights)) {
        stopifnot(length(heights) == nrow)
    }
    ## use widths/heights if supplied
    if (is.null(ncol) && !is.null(widths)) {
        ncol <- length(widths)
    }
    if (is.null(nrow) && !is.null(heights)) {
        nrow <- length(heights)
    }
    ## work out the missing one
    if (is.null(nrow) && !is.null(ncol)) {
        nrow <- ceiling(n/ncol)
    }
    if (is.null(ncol) && !is.null(nrow)) {
        ncol <- ceiling(n/nrow)
    }
    
    ## it may happen that sufficient info was passed, but incompatible with number of grobs
    ## (fewer cells)
    stopifnot(nrow * ncol >= n)
    
    ## last case: nothing exists
    if (is.null(nrow) && is.null(ncol) && is.null(widths) && is.null(heights)) {
        nm <- grDevices::n2mfrow(n)
        nrow <- nm[1]
        ncol <- nm[2]
    }
    
    is_full <- ((nrow*ncol) %% n) > 0
    if (is_full) {
        message('adding dummy grobs')
        # trouble, we need to add dummy grobs to fill the layout
        grobs <- c(grobs, rep(list(.dummy_gtable), nrow * ncol - n))
        n <- length(grobs)
        
        # add dummy labels if needed
        if ((!is.null(labels)) && (length(labels) != nrow * ncol)) {
            labels <- c(labels, rep("", nrow * ncol - length(labels)))
        }
    }
    
    ## case numeric
    if (is.numeric(widths) && !inherits(widths, "unit")) {
        widths <- lapply(widths, unit, "null")
    }
    if (is.numeric(heights) && !inherits(heights, "unit")) {
        heights <- lapply(heights, unit, "null")
    }
    
    ## sizes
    if (is.null(widths)) 
        widths <- lapply(rep(1, n), unit, "null")
    if (is.null(heights)) 
        heights <- lapply(rep(1, n), unit, "null")
    
    # user may naively have passed grid units, but only unit.list units work well with `[`
    # so convert to this class
    if (grid::is.unit(widths)) 
        widths <- as.unit.list(widths)
    if (grid::is.unit(heights)) 
        widths <- as.unit.list(heights)
    
    # indexing is problematic, wrap in list
    if (grid::is.unit(widths) && length(widths) == 1) {
        widths <- list(widths)
    }
    if (grid::is.unit(heights) && length(heights) == 1) {
        heights <- list(heights)
    }
    
    ## split the list into rows/cols
    nrc <- if (byrow) 
        nrow else ncol
    if (nrc == 1) {
        splits <- rep(1, n)
    } else {
        seqgrobs <- seq_along(grobs)
        splits <- cut(seqgrobs, nrc, labels = seq_len(nrc))
        ## widths and heights refer to the layout repeat for corresponding grobs
        
        repw <- rep_len(seq_along(widths), length.out=n)
        reph <- rep_len(seq_along(heights), length.out=n)
        widths <- c(matrix(widths[repw], ncol = nrc, byrow = !byrow))
        heights <- c(matrix(heights[reph], ncol = nrc, byrow = byrow))
        
    }
    
    
    fg <- mapply(gtable_frame, g = grobs, width = widths, height = heights, MoreArgs = list(debug = debug), 
                 SIMPLIFY = FALSE)
    
    
    if (!is.null(labels)) {
        stopifnot(length(labels) == length(fg))
        # make grobs
        labels <- do.call(label_grid, c(list(labels), label.args))
        # add each grob to the whole gtable
        fg <- mapply(function(g, l) {
            gtable::gtable_add_grob(g, l, t = 1, l = 1, b = nrow(g), r = ncol(g), z = Inf, 
                                    clip = "off", name = "label")
        }, g = fg, l = labels, SIMPLIFY = FALSE)
    }
    
    spl <- split(fg, splits)
    if (byrow) {
        rows <- lapply(spl, function(.r) do.call(gridExtra::gtable_cbind, .r))
        gt <- do.call(gridExtra::gtable_rbind, rows)
    } else {
        # fill colwise
        cols <- lapply(spl, function(.c) do.call(gridExtra::gtable_rbind, .c))
        gt <- do.call(gridExtra::gtable_cbind, cols)
    }
    
    
    ## titles given as strings are converted to text grobs
    if (is.character(top)) {
        top <- textGrob(top)
    }
    if (is.grob(top)) {
        h <- grobHeight(top) + padding
        gt <- gtable_add_rows(gt, heights = h, 0)
        gt <- gtable_add_grob(gt, top, t = 1, l = 1, r = ncol(gt), z = Inf, clip = clip)
    }
    if (is.character(bottom)) {
        bottom <- textGrob(bottom)
    }
    if (is.grob(bottom)) {
        h <- grobHeight(bottom) + padding
        gt <- gtable_add_rows(gt, heights = h, -1)
        gt <- gtable_add_grob(gt, bottom, t = nrow(gt), l = 1, r = ncol(gt), z = Inf, clip = clip)
    }
    if (is.character(left)) {
        left <- textGrob(left, rot = 90)
    }
    if (is.grob(left)) {
        w <- grobWidth(left) + padding
        gt <- gtable_add_cols(gt, widths = w, 0)
        gt <- gtable_add_grob(gt, left, t = 1, b = nrow(gt), l = 1, r = 1, z = Inf, clip = clip)
    }
    if (is.character(right)) {
        right <- textGrob(right, rot = -90)
    }
    if (is.grob(right)) {
        w <- grobWidth(right) + padding
        gt <- gtable_add_cols(gt, widths = w, -1)
        gt <- gtable_add_grob(gt, right, t = 1, b = nrow(gt), l = ncol(gt), r = ncol(gt), 
                              z = Inf, clip = clip)
    }
    
    if (draw) {
        if (newpage) 
            grid.newpage()
        grid.draw(gt)
    }
    class(gt) <- c("egg", class(gt))
    invisible(gt)  # return the full gtable
}



##' @noRd
##' @importFrom grDevices dev.interactive dev.new
##' @export
print.egg <- function(x, ...) {
    grid.newpage()
    grid.draw(x)
}

#' expose_layout
#'
#' @description Schematic view of a ggplot object's layout.
#' @param p ggplot
#' @param draw logical, draw the gtable
#' @param newpage logical
#'
#' @return gtable
#' @export
#'
#' @examples
#' p1 <- qplot(mpg, wt, data=mtcars, colour=cyl)
#' p2 <- qplot(mpg, data = mtcars) + ggtitle('title')
#' p3 <- qplot(mpg, data = mtcars, geom = 'dotplot')
#' p4 <- p1 + facet_wrap(~carb, nrow=1) + theme(legend.position='none') +
#'   ggtitle('facetted plot')
#' pl <- lapply(list(p1,p2, p3, p4), expose_layout, FALSE, FALSE)
#' grid.arrange(grobs=pl, widths=c(1.2,1,1),
#'              layout_matrix = rbind(c(1, 2, 3),
#'                                    c(4, 4, 4)))
expose_layout <- function(p, draw = TRUE, newpage = TRUE) {
    g <- ggplotGrob(p)
    lay <- g[["layout"]]
    gt <- g
    
    ids <- c("background", "panel", "axis", "lab", "guide", "strip", "title")
    
    replace_grob <- function(idname, col) {
        id <- grepl(idname, lay$name)
        pos <- lay[id, ]
        newgrob <- rectGrob(gp = gpar(col = "white", lwd = 1.2, fill = col))
        gt$grobs[id] <- replicate(nrow(pos), newgrob, simplify = FALSE)
    }
    
    cols <- c("grey95", "#FBB4AE", "#B3CDE3", "#CCEBC5", "#DECBE4", "#FED9A6", "#FFFFCC", 
        "#E5D8BD", "#FDDAEC")
    
    for (ii in seq_along(ids)) {
        id <- grepl(ids[ii], lay$name)
        pos <- lay[id, ]
        newgrob <- rectGrob(gp = gpar(col = "white", lwd = 1.2, fill = cols[ii]))
        gt$grobs[id] <- replicate(nrow(pos), newgrob, simplify = FALSE)
    }
    
    
    if (draw) {
        if (newpage) 
            grid.newpage()
        grid.draw(gt)
    }
    gt
}

#' Theme with minimalistic (and opinionated) defaults suitable for publication
#'
#' @inheritParams ggplot2::theme_bw
#' @importFrom ggplot2 theme_bw element_line element_rect element_text
#' @importFrom grid unit
#' @export
#' @examples
#' library(ggplot2)
#' 
#' d = data.frame(
#'   x = 1:90,
#'   y = rnorm(90),
#'   red = rep(letters[1:3], 30),
#'   blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))
#' 
#' p <- ggplot(d) +
#'   geom_point(aes(x = x, y = y)) +
#'   facet_grid(red ~ blue)
#' tag_facet(p + theme_article())
#' p + theme_presentation()
#' 
#' # example of use with cairo device
#' # ggsave("fig_talk.pdf", p + theme_presentation("Source Sans Pro"), 
#' #          width=14, height=7, device = cairo_pdf, bg='transparent')
theme_article <- function(base_size = 11, base_family = "") {
  gray <- "#464646"
  fg <- "#000000"
  theme_bw(base_size = base_size, base_family = base_family) + 
    theme(line = element_line(colour = gray), 
          rect = element_rect(fill = NA, colour = NA), 
          text = element_text(colour = fg), 
          axis.ticks = element_line(colour = gray), 
          legend.key = element_rect(colour = NA, fill = NA), 
          legend.key.height = unit(3,"mm"),
          panel.border = element_rect(colour = gray, fill = NA), 
          panel.grid = element_blank(), 
          plot.background = element_blank(), 
          panel.background=element_blank(), 
          strip.background = element_blank())
}

#' Theme with minimalistic (and opinionated) defaults suitable for presentation
#'
#' @inheritParams ggplot2::theme_bw
#' @importFrom ggplot2 theme_bw element_line element_rect element_text
#' @importFrom grid unit
#' @describeIn theme
#' @export
theme_presentation <- function(base_size = 24, base_family = "") {
  gray <- "#464646"
  bg = 'grey98'
  fg <- "#000000"
  theme_bw(base_size = base_size, base_family = base_family) + 
    theme(line = element_line(colour = gray), 
          rect = element_rect(fill = NA, colour = NA), 
          text = element_text(colour = fg), 
          axis.ticks = element_line(colour = gray), 
          legend.key = element_rect(colour = NA, fill = bg), 
          legend.key.height = unit(3,"mm"),
          panel.border = element_rect(colour = gray, fill = NA), 
          panel.grid = element_blank(), 
          panel.background=element_rect(fill=bg),
          strip.background = element_blank())
}

#' tag_facet
#'
#' @description Adds a dummy text layer to a ggplot to label facets and sets facet strips to blank. 
#' This is the typical formatting for some journals that consider facets as subfigures 
#' and want to minimise margins around figures.
#' @param p ggplot
#' @param open opening character, default: (
#' @param close  closing character, default: )
#' @param tag_pool character vector to pick tags from
#' @param x x position within panel, default: -Inf
#' @param y y position within panel, default: Inf
#' @param hjust hjust
#' @param vjust vjust
#' @param fontface fontface
#' @param family font family
#' @param ... further arguments passed to geom_text layer
#'
#' @return plot with facet strips removed and replaced by in-panel tags 
#' @importFrom ggplot2 geom_text ggplot_build theme element_blank aes_string
#' @export
#' @examples
#' library(ggplot2)
#' mydf = data.frame(
#'   x = 1:90,
#'   y = rnorm(90),
#'   red = rep(letters[1:3], 30),
#'   blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))
#' 
#' p <- ggplot(mydf) +
#'   geom_point(aes(x = x, y = y)) +
#'   facet_wrap(
#'     ~ red + blue)
#' tag_facet(p)

tag_facet <- function(p, open = "(", close = ")", tag_pool = letters, x = -Inf, y = Inf, 
                      hjust = -0.5, vjust = 1.5, fontface = 2, family = "", ...) {
  
  gb <- ggplot_build(p)
  lay <- gb$layout$layout
  tags <- cbind(lay, label = paste0(open, tag_pool[lay$PANEL], close), x = x, y = y)
  p + geom_text(data = tags, aes_string(x = "x", y = "y", label = "label"), ..., hjust = hjust, 
                vjust = vjust, fontface = fontface, family = family, inherit.aes = FALSE) + theme(strip.text = element_blank(), 
                                                                                                  strip.background = element_blank())
}


#' tag_facet_outside
#'
#' @description Adds a dummy text layer to a ggplot to label facets and sets facet strips to blank. 
#' This is the typical formatting for some journals that consider facets as subfigures 
#' and want to minimise margins around figures.
#' @param p ggplot
#' @param open opening character, default: (
#' @param close  closing character, default: )
#' @param tag_fun_top labelling function 
#' @param tag_fun_right labelling function
#' @param x x position within cell
#' @param y y position within cell
#' @param hjust hjust
#' @param vjust vjust
#' @param fontface fontface
#' @param family font family
#' @param draw logical: draw the resulting gtable
#' @param ... further arguments passed to geom_text layer
#' @return plot with facet strips removed and replaced by in-panel tags 
#' @importFrom ggplot2 ggplot_gtable geom_text ggplot_build theme element_blank 
#' @importFrom utils as.roman
#' @export
#' @examples
#' library(ggplot2)
#' d = data.frame(
#'   x = 1:90,
#'   y = rnorm(90),
#'   red = rep(letters[1:3], 30),
#'   blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))
#' 
#' p <- ggplot(d) +
#'   geom_point(aes(x = x, y = y)) +
#'   facet_grid(red ~ blue)
#'   
#' tag_facet_outside(p)
#' 
tag_facet_outside <-  function(p, open=c("(",""), close = c(")","."),
                               tag_fun_top = function(i) letters[i],
                               tag_fun_right = utils::as.roman,
                               x = c(0,0), y = c(0.5, 1),
                               hjust = c(0,0), vjust = c(0.5,1), 
                               fontface = c(2,2), family="", draw = TRUE, ...){
  
  gb <- ggplot_build(p + theme(strip.text = element_blank(), 
                             strip.background = element_blank()))
  lay <- gb$layout$layout
  
  tags_top <- paste0(open[1],tag_fun_top(unique(lay$COL)),close[1])
  tags_right <- paste0(open[2],tag_fun_right(unique(lay$ROW)),close[2])
  
  tl <- lapply(tags_top, grid::textGrob, x=x[1], y=y[1],
               hjust=hjust[1], vjust=vjust[1], 
               gp=grid::gpar(fontface=fontface[1], fontfamily = family, ...))
  rl <- lapply(tags_right, grid::textGrob, x=x[2], y=y[2],
               hjust=hjust[2], vjust=vjust[2], 
               gp=grid::gpar(fontface=fontface[2], fontfamily = family, ...))
  
  
  g <- ggplot_gtable(gb)
  g <- gtable::gtable_add_rows(g, grid::unit(1,"line"), pos = 0)
  l <- unique(g$layout[grepl("panel",g$layout$name), "l"])
  g <- gtable::gtable_add_grob(g, grobs = tl, t=1, l=l)
  
  wm <- do.call(grid::unit.pmax, lapply(rl, grid::grobWidth))
  g <- gtable::gtable_add_cols(g, wm, pos = max(l))
  t <- unique(g$layout[grepl("panel",g$layout$name), "t"])
  g <- gtable::gtable_add_grob(g, grobs = rl, t=t, l=max(l) + 1)
  g <- gtable::gtable_add_cols(g, unit(2,"mm"), pos = max(l))
  
  if(draw){
    grid::grid.newpage()
    grid::grid.draw(g)
  }
  invisible(g)
}

#' symmetric_range
#'
#' @description Function to ensure that a position scale is symmetric about 0
#' @param range range of the data
#'
#' @return symmetric range
#' @importFrom ggplot2 scale_x_continuous
#' @export
#' @examples
#' library(ggplot2)
#' df = data.frame(x = c(1, 2),
#'                 y = c(5, 0.2),
#'                 group = c(1, 2))
#' p <- ggplot(df, aes(x = x, y = y)) + 
#'   geom_point() + 
#'   facet_wrap( ~ group, scale =
#'                 "free")
#' p + scale_y_continuous(limits = symmetric_range)
symmetric_range <- function(range) {
  max_abs <- max(abs(range))
  c(-max_abs, max_abs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geom_custom.r
\name{geom_custom}
\alias{geom_custom}
\title{geom_custom}
\usage{
geom_custom(mapping = NULL, data = NULL, inherit.aes = TRUE, ...)
}
\arguments{
\item{mapping}{mapping}

\item{data}{data}

\item{inherit.aes}{inherit.aes}

\item{...}{arguments passed to the geom's draw_group method}
}
\value{
layer
}
\description{
Draw user-defined grobs, typically annotations, at specific locations.
}
\examples{
library(grid)
d <- data.frame(x=rep(1:3, 4), f=rep(letters[1:4], each=3))
gl <- replicate(4, matrix(sample(palette(), 9, TRUE), 3, 3), FALSE)
dummy <- data.frame(f=letters[1:4], data = I(gl))
ggplot(d, aes(f,x)) +
  facet_wrap(~f)+
  theme_bw() +
  geom_point()+
  geom_custom(data = dummy, aes(data = data, y = 2),
              grob_fun = function(x) rasterGrob(x, interpolate = FALSE,
                                                width=unit(1,'cm'),
                                                height=unit(1,'cm')))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/symmetric_scale.r
\name{symmetric_range}
\alias{symmetric_range}
\title{symmetric_range}
\usage{
symmetric_range(range)
}
\arguments{
\item{range}{range of the data}
}
\value{
symmetric range
}
\description{
Function to ensure that a position scale is symmetric about 0
}
\examples{
library(ggplot2)
ggplot(mpg, aes(cty, hwy)) + 
geom_point() +
  scale_x_continuous(limits = symmetric_range)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/theme.r
\name{theme_article}
\alias{theme_article}
\title{Theme with minimalistic (and opinionated) defaults suitable for publication}
\usage{
theme_article(base_size = 11, base_family = "")
}
\arguments{
\item{base_size}{base font size}

\item{base_family}{base font family}
}
\description{
Theme with minimalistic (and opinionated) defaults suitable for publication
}
\examples{
library(ggplot2)

d = data.frame(
  x = 1:90,
  y = rnorm(90),
  red = rep(letters[1:3], 30),
  blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))

p <- ggplot(d) +
  geom_point(aes(x = x, y = y)) +
  facet_grid(red ~ blue)
tag_facet(p + theme_article())
p + theme_presentation()

# example of use with cairo device
# ggsave("fig_talk.pdf", p + theme_presentation("Source Sans Pro"), 
#          width=14, height=7, device = cairo_pdf, bg='transparent')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expose_layout.r
\name{expose_layout}
\alias{expose_layout}
\title{expose_layout}
\usage{
expose_layout(p, draw = TRUE, newpage = TRUE)
}
\arguments{
\item{p}{ggplot}

\item{draw}{logical, draw the gtable}

\item{newpage}{logical}
}
\value{
gtable
}
\description{
Schematic view of a ggplot object's layout.
}
\examples{
p1 <- qplot(mpg, wt, data=mtcars, colour=cyl)
p2 <- qplot(mpg, data = mtcars) + ggtitle('title')
p3 <- qplot(mpg, data = mtcars, geom = 'dotplot')
p4 <- p1 + facet_wrap(~carb, nrow=1) + theme(legend.position='none') +
  ggtitle('facetted plot')
pl <- lapply(list(p1,p2, p3, p4), expose_layout, FALSE, FALSE)
grid.arrange(grobs=pl, widths=c(1.2,1,1),
             layout_matrix = rbind(c(1, 2, 3),
                                   c(4, 4, 4)))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tag_facet.r
\name{tag_facet}
\alias{tag_facet}
\title{tag_facet}
\usage{
tag_facet(p, open = "(", close = ")", tag_pool = letters, x = -Inf,
  y = Inf, hjust = -0.5, vjust = 1.5, fontface = 2, family = "",
  ...)
}
\arguments{
\item{p}{ggplot}

\item{open}{opening character, default: (}

\item{close}{closing character, default: )}

\item{tag_pool}{character vector to pick tags from}

\item{x}{x position within panel, default: -Inf}

\item{y}{y position within panel, default: Inf}

\item{hjust}{hjust}

\item{vjust}{vjust}

\item{fontface}{fontface}

\item{family}{font family}

\item{...}{further arguments passed to geom_text layer}
}
\value{
plot with facet strips removed and replaced by in-panel tags
}
\description{
Adds a dummy text layer to a ggplot to label facets and sets facet strips to blank. 
This is the typical formatting for some journals that consider facets as subfigures 
and want to minimise margins around figures.
}
\examples{
library(ggplot2)
mydf = data.frame(
  x = 1:90,
  y = rnorm(90),
  red = rep(letters[1:3], 30),
  blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))

p <- ggplot(mydf) +
  geom_point(aes(x = x, y = y)) +
  facet_wrap(
    ~ red + blue)
tag_facet(p)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gtable_frame.r
\name{ggarrange}
\alias{ggarrange}
\title{ggarrange}
\usage{
ggarrange(..., plots = list(...), nrow = NULL, ncol = NULL,
  widths = NULL, heights = NULL, byrow = TRUE, top = NULL,
  bottom = NULL, left = NULL, right = NULL, padding = unit(0.5,
  "line"), clip = "on", draw = TRUE, newpage = TRUE, debug = FALSE,
  labels = NULL, label.args = list(gp = grid::gpar(font = 4, cex =
  1.2)))
}
\arguments{
\item{...}{ggplot objects}

\item{plots}{list of ggplots}

\item{nrow}{number of rows}

\item{ncol}{number of columns}

\item{widths}{list of requested widths}

\item{heights}{list of requested heights}

\item{byrow}{logical, fill by rows}

\item{top}{optional string, or grob}

\item{bottom}{optional string, or grob}

\item{left}{optional string, or grob}

\item{right}{optional string, or grob}

\item{padding}{unit of length one, margin around annotations}

\item{clip}{argument of gtable}

\item{draw}{logical: draw or return a grob}

\item{newpage}{logical: draw on a new page}

\item{debug}{logical, show layout with thin lines}

\item{labels}{character labels used for annotation of subfigures}

\item{label.args}{label list of parameters for the formatting of labels}
}
\value{
gtable of aligned plots
}
\description{
Arrange multiple ggplot objects on a page, aligning the plot panels.
}
\examples{
p1 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
  geom_point()
p2 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
  geom_point() + facet_wrap( ~ cyl, ncol=2, scales = 'free') +
  guides(colour='none') +
  theme()
ggarrange(p1, p2, widths = c(2,1), labels = c('a', 'b'))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/set_panel_size.r
\name{set_panel_size}
\alias{set_panel_size}
\title{set_panel_size}
\usage{
set_panel_size(p = NULL, g = ggplot2::ggplotGrob(p), file = NULL,
  margin = unit(1, "mm"), width = unit(4, "cm"), height = unit(4,
  "cm"))
}
\arguments{
\item{p}{ggplot2}

\item{g}{gtable}

\item{file}{optional output filename}

\item{margin}{grid unit}

\item{width}{grid unit, requested panel width}

\item{height}{grid unit, requested panel height}
}
\value{
gtable with fixed panel sizes
}
\description{
Set the panel width/height of a ggplot to a fixed value.
}
\examples{
p1 <- qplot(mpg, wt, data=mtcars, colour=cyl)
p2 <- p1 + facet_wrap(~carb, nrow=1)
grid.arrange(grobs=lapply(list(p1,p2), set_panel_size))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gtable_frame.r
\name{gtable_frame}
\alias{gtable_frame}
\title{gtable_frame}
\usage{
gtable_frame(g, width = unit(1, "null"), height = unit(1, "null"),
  debug = FALSE)
}
\arguments{
\item{g}{gtable}

\item{width}{requested width}

\item{height}{requested height}

\item{debug}{logical draw gtable cells}
}
\value{
3x3 gtable wrapping the plot
}
\description{
Reformat the gtable associated with a ggplot object into a 3x3 gtable where the central cell corresponds to the plot panel(s).
}
\examples{
library(grid)
library(gridExtra)
p1 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
  geom_point()

p2 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
  geom_point() + facet_wrap( ~ cyl, ncol=2, scales = 'free') +
  guides(colour='none') +
  theme()

p3 <- ggplot(mtcars, aes(mpg, wt, colour = factor(cyl))) +
  geom_point() + facet_grid(. ~ cyl, scales = 'free')

g1 <- ggplotGrob(p1);
g2 <- ggplotGrob(p2);
g3 <- ggplotGrob(p3);
fg1 <- gtable_frame(g1)
fg2 <- gtable_frame(g2)
fg12 <- gtable_frame(gtable_rbind(fg1,fg2), width=unit(2,'null'), height=unit(1,'null'))
fg3 <- gtable_frame(g3, width=unit(1,'null'), height=unit(1,'null'))
grid.newpage()
combined <- gtable_cbind(fg12, fg3)
grid.draw(combined)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tag_facet.r
\name{tag_facet_outside}
\alias{tag_facet_outside}
\title{tag_facet_outside}
\usage{
tag_facet_outside(p, open = c("(", ""), close = c(")", "."),
  tag_fun_top = function(i) letters[i],
  tag_fun_right = utils::as.roman, x = c(0, 0), y = c(0.5, 1),
  hjust = c(0, 0), vjust = c(0.5, 1), fontface = c(2, 2),
  family = "", draw = TRUE, ...)
}
\arguments{
\item{p}{ggplot}

\item{open}{opening character, default: (}

\item{close}{closing character, default: )}

\item{tag_fun_top}{labelling function}

\item{tag_fun_right}{labelling function}

\item{x}{x position within cell}

\item{y}{y position within cell}

\item{hjust}{hjust}

\item{vjust}{vjust}

\item{fontface}{fontface}

\item{family}{font family}

\item{draw}{logical: draw the resulting gtable}

\item{...}{further arguments passed to geom_text layer}
}
\value{
plot with facet strips removed and replaced by in-panel tags
}
\description{
Adds a dummy text layer to a ggplot to label facets and sets facet strips to blank. 
This is the typical formatting for some journals that consider facets as subfigures 
and want to minimise margins around figures.
}
\examples{
library(ggplot2)
d = data.frame(
  x = 1:90,
  y = rnorm(90),
  red = rep(letters[1:3], 30),
  blue = c(rep(1, 30), rep(2, 30), rep(3, 30)))

p <- ggplot(d) +
  geom_point(aes(x = x, y = y)) +
  facet_grid(red ~ blue)
  
tag_facet_outside(p)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/theme.r
\name{theme_presentation}
\alias{theme_presentation}
\title{Theme with minimalistic (and opinionated) defaults suitable for presentation}
\usage{
theme_presentation(base_size = 24, base_family = "")
}
\arguments{
\item{base_size}{base font size}

\item{base_family}{base font family}
}
\description{
Theme with minimalistic (and opinionated) defaults suitable for presentation
}
